/*
 * nokia5110lcd.h
 *
 *  Created on: 2014-01-14
 *      Author: Przemek
 */

#ifndef NOKIA5110LCD_H_
#define NOKIA5110LCD_H_


#define TEKST 0


/* 84 x 6 bajtw */
#define LCD_X 84
#define LCD_Y 6

// komendy czy polecenia
#define lcd_komenda     0
#define lcd_dane    1

#define LCD_HOME lcd_write_byte(LCD_CMD, 0x40);lcd_write_byte(LCD_CMD, 0x80);
#define LCD_GOTO(x,y) lcd_write_byte(LCD_CMD, 0x40|(y));lcd_write_byte(LCD_CMD, 0x80|(x));

/* CLK */
#define LCD_CLK_SET       PORTB |=  (1<<PB5);
#define LCD_CLK_CLR       PORTB &= ~(1<<PB5);
#define LCD_CLK_SET_OUT   DDRB  |=  (1<<PB5);
/* DATA */
#define LCD_DATA_SET      PORTB |=  (1<<PB3);
#define LCD_DATA_CLR      PORTB &= ~(1<<PB3);
#define LCD_DATA_SET_OUT  DDRB  |=  (1<<PB3);
/* DC */
#define LCD_DC_SET        PORTB |=  (1<<PB4);
#define LCD_DC_CLR        PORTB &= ~(1<<PB4);
#define LCD_DC_SET_OUT    DDRB  |=  (1<<PB4);
/* CE */
#define LCD_CE_SET        PORTC |=  (1<<PC0);
#define LCD_CE_CLR        PORTC &= ~(1<<PC0);
#define LCD_CE_SET_OUT    DDRC  |=  (1<<PC0);
/* RST */
#define LCD_RST_SET       PORTC |=  (1<<PC1);
#define LCD_RST_CLR       PORTC &= ~(1<<PC1);
#define LCD_RST_SET_OUT   DDRC  |=  (1<<PC1);

void nokialcd_init(void);
void nokialcd_wyslij_bajt( unsigned char, unsigned char );
void nokialcd_wyswietl_obrazek(unsigned char [],char , char , char , char );
void nokialcd_ustaw_kursor(uint8_t, uint8_t);
void nokialcd_czysc_ekran(void);
void nokialcd_negatyw(uint8_t);

#if TEKST == 1
void nokialcd_pisz_znak(char);
void nokialcd_pisz_tekst(char*);
void nokialcd_pisz_liczbe(int);
#endif


void nokialcd_buf_wyswietl(void);
void nokialcd_buf_czysc_bufor(void);
void nokialcd_buf_zapal_pixel(uint8_t, uint8_t,uint8_t);
//void nokialcd_buf_narysuj_linie(uint8_t, uint8_t, uint8_t, uint8_t,uint8_t);
void nokialcd_buf_rysuj_linie_3p(uint8_t, uint8_t, uint8_t,uint8_t,uint8_t);
void nokialcd_buf_rysuj_okrag(uint8_t , uint8_t , uint8_t,uint8_t);
void nokialcd_buf_rysuj_prostokat(uint8_t , uint8_t, uint8_t, uint8_t,uint8_t);
void nokialcd_buf_rysuj_obrazek(unsigned char [],char , char, char, char,uint8_t);

// kierunek 1 oznacza linie pozioma, natomiast 0 - pionowa
void nokia_buf_narysuj_linie_prosta(uint8_t x, uint8_t y , uint8_t dlugosc, uint8_t kierunek, uint8_t zapal);
#endif /* NOKIA5110LCD_H_ */
